/*! 
    \file particle_e,otter.h
    \brief Definition of a ParticleEmitter
*/

#ifndef _PARTICLE_EMITTER_H
#define _PARTICLE_EMITTER_H

#include "p_node.h"

// FORWARD DEFINITION 
struct Particle;
class ParticleSystem;


//! A default singleton class.
class ParticleEmitter : public PNode {

 public:
  ParticleEmitter(void);
  virtual ~ParticleEmitter(void);

  void tick(float dt);

 private:
  Vector direction;     //!< emition direction
  float angle;          //!< max angle from the direction of the emitter

  float emissionRate;   //!< amount of particles per seconds emitted by emiter
  
  float velocity;       //!< the contant speed a particle gets if been emitted
  float minVel, maxVel; //!< the minimal and maximal velocity a particle has

  float timeToLive;     //!< this is the global time to live (ttl) definition
  float minTTL, maxTTL  //!<
};

#endif /* _PARTICLE_EMITTER_H */
