/*! 
    \file particle_engine.h
    \brief Definition of the ParticleEngine
*/

#ifndef _PARTICLE_ENGINE_H
#define _PARTICLE_ENGINE_H

#include "base_object.h"

// FORWARD DEFINITION 
template<class T> class tList;
class ParticleSystem;


//! A default singleton class.
class ParticleEngine : public BaseObject {

 public:
  static ParticleEngine* getInstance(void);
  virtual ~ParticleEngine(void);

  void tick(float dt);

 private:
  ParticleEngine(void);
  static ParticleEngine* singletonRef;

  tList<ParticleSystem>* partSysList;

};

#endif /* _PARTICLE_ENGINE_H */
