/*! 
    \file particle_system.h

*/

#ifndef _PARTICLE_SYSTEM_H
#define _PARTICLE_SYSTEM_H

#include "base_object.h"
#include "vector.h"
// FORWARD DEFINITION

class Material;
class Vector;


//! A struct for one Particle
typedef struct Particle
{
  float timeToLive;
  Vector position;
  Quaternion rotation;
  Material* material;  
};

//! A class to handle particle Systems
class ParticleSystem : public BaseObject {

 public:
  ParticleSystem();
  virtual ~ParticleSystem();


 private:

  int particleCount;

  Particle* particles;
};

#endif /* _PARTICLE_SYSTEM_H */
